/*
 * from inet.h,v 1.31.2.5 1995/01/13 19:18:51 jch Exp
 */

/*
 * ------------------------------------------------------------------------
 * 
 * Copyright (c) 1996, 1997 The Regents of the University of Michigan
 * All Rights Reserved
 *  
 * Royalty-free licenses to redistribute GateD Release
 * 3 in whole or in part may be obtained by writing to:
 * 
 * 	Merit GateDaemon Project
 * 	4251 Plymouth Road, Suite C
 * 	Ann Arbor, MI 48105
 *  
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * ------------------------------------------------------------------------
 * 
 * Copyright (c) 1990,1991,1992,1993,1994,1995 by Cornell University.
 *     All rights reserved.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * GateD is based on Kirton's EGP, UC Berkeley's routing
 * daemon	 (routed), and DCN's HELLO routing Protocol.
 * Development of GateD has been supported in part by the
 * National Science Foundation.
 * 
 * ------------------------------------------------------------------------
 * 
 * Portions of this software may fall under the following
 * copyrights:
 * 
 * Copyright (c) 1988 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms are
 * permitted provided that the above copyright notice and
 * this paragraph are duplicated in all such forms and that
 * any documentation, advertising materials, and other
 * materials related to such distribution and use
 * acknowledge that the software was developed by the
 * University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote
 * products derived from this software without specific
 * prior written permission.  THIS SOFTWARE IS PROVIDED
 * ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */


/* REALLY ugly Solaris hack */
#ifdef	SUNOS5_0
#include	<netinet/in.h>
/* Unaligned IPv6 header */
typedef struct ipv6h_s {
	u_char  ipv6h_vers_and_flow[4]; /* vers # in hi 4 bits, rest flow */
	u_char  ipv6h_length[2];
	u_char  ipv6h_nexthdr;
	u_char  ipv6h_hoplimit;
	u_char  ipv6h_src[16];
	u_char  ipv6h_dst[16];
} ipv6h_t;
#endif	/* SUNOS5_0 */

/* for old non rfc inria headers */
#ifdef _OLD_INRIA_STRUCT_
#define ip6_hdr			ipv6
#define ip6_nxt			ip6_nh
#define ip6_flow		ip6_head
#define ip6_plen		ip6_len

#define ICMP6_DST_UNREACH	ICMP6_UNREACH
#define ICMP6_ECHO_REPLY	ICMP6_ECHOREPLY
#define ICMP6_ECHO_REQUEST	ICMP6_ECHO
#define ICMP6_MEMBERSHIP_QUERY	ICMP6_GROUPMEM_QUERY
#define ICMP6_MEMBERSHIP_REDUCTION	ICMP6_GROUPMEM_TERM
#define ICMP6_MEMBERSHIP_REPORT	ICMP6_GROUPMEM_REPORT
#define ICMP6_PACKET_TOO_BIG	ICMP6_PKTTOOBIG
#define ICMP6_PARAM_PROB	ICMP6_PARAMPROB
#define ICMP6_TIME_EXCEEDED	ICMP6_TIMXCEED
#define ND_NEIGHBOR_ADVERT	ICMP6_ADVERTISEMENT_ND
#define ND_NEIGHBOR_SOLICIT	ICMP6_SOLICITATION_ND
#define ND_REDIRECT		ICMP6_REDIRECT
#define ND_ROUTER_ADVERT	ICMP6_ADVERTISEMENT_RT
#define ND_ROUTER_SOLICIT	ICMP6_SOLICITATION_RT
#ifdef ICMP6_ND_PRIORITY
#define ND_DEFAULT_CLASS	ICMP6_ND_PRIORITY
#else
#define ND_DEFAULT_CLASS	ICMP6_ND_CLASS
#endif
#define ND_DEFAULT_HOPLIM	ICMP6_ND_HOPS
#define MLD6_LISTENER_QUERY ICMP6_GROUPMEM_QUERY
#define MLD6_LISTENER_REPORT ICMP6_GROUPMEM_REPORT
#define MLD6_LISTENER_DONE ICMP6_GROUPMEM_TERM

struct icmp6_hdr {
    u_int8_t		icmp6_type;	/* type field */
    u_int8_t		icmp6_code;	/* code field */
    u_int16_t		icmp6_cksum;	/* checksum field */
    union {
	u_int32_t	icmp6_un_data32[1];	/* type-specific field */
	u_int16_t	icmp6_un_data16[2];	/* type-specific field */
	u_int8_t	icmp6_un_data8[4];	/* type-specific field */
    } icmp6_dataun;
};
#undef	icmp6_id
#undef	icmp6_seq
#undef	icmp6_mrd
#define icmp6_id	icmp6_data16[0]	/* echo request/reply */
#define icmp6_seq	icmp6_data16[1]	/* echo request/reply */
#define icmp6_data32	icmp6_dataun.icmp6_un_data32
#define icmp6_data16	icmp6_dataun.icmp6_un_data16
#define icmp6_data8	icmp6_dataun.icmp6_un_data8

struct nd_router_solicit {	/* router solicitation */
    struct icmp6_hdr	nd_rs_hdr;
};
#define nd_rs_type	nd_rs_hdr.icmp6_type
#define nd_rs_code	nd_rs_hdr.icmp6_code
#define nd_rs_cksum	nd_rs_hdr.icmp6_cksum
#define nd_rs_reserved	nd_rs_hdr.icmp6_data32[0]

struct nd_router_advert {	/* router advertisement */
    struct icmp6_hdr	nd_ra_hdr;
    u_int32_t		nd_ra_reachable;	/* reachable time */
    u_int32_t		nd_ra_retransmit;	/* retransmit timer */
};
#define nd_ra_type		nd_ra_hdr.icmp6_type
#define nd_ra_code		nd_ra_hdr.icmp6_code
#define nd_ra_cksum		nd_ra_hdr.icmp6_cksum
#define nd_ra_curhoplimit	nd_ra_hdr.icmp6_data8[0]
#define nd_ra_flags_reserved	nd_ra_hdr.icmp6_data8[1]
#define nd_ra_router_lifetime	nd_ra_hdr.icmp6_data16[1]

struct nd_neighbor_solicit {	/* neighbor solicitation */
    struct icmp6_hdr	nd_ns_hdr;
    struct in6_addr	nd_ns_target;	/* target address */
};

struct nd_redirect {
    struct icmp6_hdr	nd_rd_hdr;
    struct in6_addr	nd_rd_target;	/* target address */
    struct in6_addr	nd_rd_dst;	/* destination address */
};

struct mld6_hdr {
    struct icmp6_hdr	mld6_hdr;
    struct in6_addr	mld6_addr;	/* multicast address */
};
#define mld6_maxdelay	mld6_hdr.icmp6_data16[0]
#define mld6_code	mld6_hdr.icmp6_code
#define mld6_cksum	mld6_hdr.icmp6_cksum
#endif /* _OLD_INRIA_STRUCT_ */

/* kernel depended macros */
#define LESS_ADDR6(a, b) \
	(((a).s6_addr[8] < (b).s6_addr[8]) || \
	 (((a).s6_addr[8] == (b).s6_addr[8]) && \
	  (((a).s6_addr[9] < (b).s6_addr[9]) || \
	   (((a).s6_addr[9] == (b).s6_addr[9]) && \
	    (((a).s6_addr[10] < (b).s6_addr[10]) || \
	     (((a).s6_addr[10] == (b).s6_addr[10]) && \
	      (((a).s6_addr[11] < (b).s6_addr[11]) || \
	       (((a).s6_addr[11] == (b).s6_addr[11]) && \
	        (((a).s6_addr[12] < (b).s6_addr[12]) || \
	         (((a).s6_addr[12] == (b).s6_addr[12]) && \
	          (((a).s6_addr[13] < (b).s6_addr[13]) || \
	           (((a).s6_addr[13] == (b).s6_addr[13]) && \
	            (((a).s6_addr[14] < (b).s6_addr[14]) || \
	             (((a).s6_addr[14] == (b).s6_addr[14]) && \
	              ((a).s6_addr[15] < (b).s6_addr[15])))))))))))))))

#ifdef INRIA
#endif /* INRIA */
#ifdef SHIN
#define s6_addr s6_addr8
#define ipv6_mreq ip6_mreq
#define ipv6mr_multiaddr imr6_multiaddr
#define ipv6mr_interface imr6_interface
#define IS_ANYADDR6(a) (((a).s6_addr32[0] == 0) \
			&& ((a).s6_addr32[1] == 0) \
			&& ((a).s6_addr32[2] == 0) \
			&& ((a).s6_addr32[3] == 0))
#define SAME_ADDR6(a, b) (((a).s6_addr32[0] == (b).s6_addr32[0]) \
			  && ((a).s6_addr32[1] == (b).s6_addr32[1]) \
			  && ((a).s6_addr32[2] == (b).s6_addr32[2]) \
			  && ((a).s6_addr32[3] == (b).s6_addr32[3]))
#endif /* SHIN */
#ifdef HYDRANGEA
#define ipv6mr_multiaddr	im6r_multiaddr
#define	ipv6mr_interface	im6r_interface
#define IS_ANYADDR6(a) (((a).s6_addr32[0] == 0) \
			&& ((a).s6_addr32[1] == 0) \
			&& ((a).s6_addr32[2] == 0) \
			&& ((a).s6_addr32[3] == 0))
#define SAME_ADDR6(a, b) (((a).s6_addr32[0] == (b).s6_addr32[0]) \
			  && ((a).s6_addr32[1] == (b).s6_addr32[1]) \
			  && ((a).s6_addr32[2] == (b).s6_addr32[2]) \
			  && ((a).s6_addr32[3] == (b).s6_addr32[3]))
#endif /* HYDRANGEA */

#ifdef	SUNOS5_0
#define IS_ANYADDR6(a) (((a).s6_addr[0] == 0) \
			&& ((a).s6_addr[1] == 0) \
			&& ((a).s6_addr[2] == 0) \
			&& ((a).s6_addr[3] == 0))
#define SAME_ADDR6(a, b) (((a).s6_addr[0] == (b).s6_addr[0]) \
			  && ((a).s6_addr[1] == (b).s6_addr[1]) \
			  && ((a).s6_addr[2] == (b).s6_addr[2]) \
			  && ((a).s6_addr[3] == (b).s6_addr[3]))
#endif	/* SUNOS5_0 */

/* macros to select IPv6 address given pointer to a struct sockaddr */

/* clear and init a sockaddr_un for Inet use */
#define	sock2in6(x)	((x)->in6.gin6_addr)
#define	sock2port6(x)	((x)->in6.gin6_port)
#define	sock2flow6(x)	((x)->in6.gin6_flowinfo)
#ifndef _SOCKADDR6_NO_SCOPE_
#define	sock2scope6(x)	((x)->in6.gin6_scope_id)
#endif /* _SOCKADDR6_NO_SCOPE_ */
#define IS_LINKLOCAL6(x)	(IN6_IS_ADDR_LINKLOCAL(&sock2in6(x)))
#define	sockclear_in6(x)	\
			bzero((void_t)(x), sizeof ((x)->in6)); \
			socktype(x) = AF_INET6; \
    			socksize(x) = sizeof ((x)->in6);
#ifdef _SOCKADDR6_NO_SCOPE_
#define	sockaddrcmp_in6(a, b)	(SAME_ADDR6(sock2in6(a), sock2in6(b)))
#else /* _SOCKADDR6_NO_SCOPE_ */
#define	sockaddrcmp_in6(a, b) \
	(SAME_ADDR6(sock2in6(a), sock2in6(b)) && \
	 (!IS_LINKLOCAL6(a) || \
	  (sock2scope6(a) ==(sock2scope6(b)))))
#endif /* _SOCKADDR6_NO_SCOPE_ */
#define	sockaddrless_in6(a, b)	(LESS_ADDR6(sock2in6(a), sock2in6(b)))
#define	sockcmp_in6(a, b)	(sock2port6(a) == sock2port6(b) && sockaddrcmp_in6(a, b))

#define	sockaddrmask_in6(addr, mask)	\
		((int *)&sock2in6(addr))[0] &= ((int *)&sock2in6(mask))[0]; \
		((int *)&sock2in6(addr))[1] &= ((int *)&sock2in6(mask))[1]; \
		((int *)&sock2in6(addr))[2] &= ((int *)&sock2in6(mask))[2]; \
		((int *)&sock2in6(addr))[3] &= ((int *)&sock2in6(mask))[3];

#define	sockmask_in6(addr, mask)	\
				sock2port6(addr) &= sock2port6(mask); \
				sockaddrmask_in6(addr, mask)

#define	inet6_addrcmp_mask(a, b, m)	\
		((!((((int *)&a)[0] ^ ((int *)&b)[0]) & ((int *)&m)[0])) && \
		 (!((((int *)&a)[1] ^ ((int *)&b)[1]) & ((int *)&m)[1])) && \
		 (!((((int *)&a)[2] ^ ((int *)&b)[2]) & ((int *)&m)[2])) && \
		 (!((((int *)&a)[3] ^ ((int *)&b)[3]) & ((int *)&m)[3])))

#define	SOCKADDR_IN6_LEN	sizeof (inet6_addr_default->in6)
#ifdef	PROTO_BGP4MP
#define	SOCKADDR_BGP6_LEN	sizeof (inet6_addr_default->bgp6)
#endif	/* PROTO_BGP4MP */

/* additional definitions to netinet/in.h */

#ifndef IPPROTO_OSPF
#define IPPROTO_OSPF 89
#endif	/* IPPROTO_OSPF */

extern int inet6_off;		/* No IPv6 actions */
extern int inet6_ipforwarding;		/* IPv6 forwarding engine enabled */

extern const bits inet6_proto_bits[];	/* Protocol types */

/* Common addresses */
extern sockaddr_un *inet6_addr_default;
extern sockaddr_un *inet6_addr_loopback;
extern sockaddr_un *inet6_addr_any;
extern sockaddr_un *inet6_addr_reject;
extern sockaddr_un *inet6_addr_blackhole;
extern sockaddr_un *inet6_addr_allnodes;
extern sockaddr_un *inet6_addr_allrouters;

#define	inet6_mask_default	inet6_masks[INET6_MASK_DEFAULT]
#define	inet6_mask_host		inet6_masks[INET6_MASK_HOST]

extern	sockaddr_un *inet6_masks[];		/* Table of all possible *contiguous* masks */
extern	byte inet6_mask_list[SOCKADDR_IN6_LEN * (sizeof (struct in6_addr) * NBBY + 1)];	/* The actual masks */

#define	INET6_LIMIT_MASKLEN	0, 128

#define	INET6_LIMIT_TTL		1, 255

#define INET6_SCOPE_NONE	0
#define INET6_SCOPE_V4COMPAT	1
#define INET6_SCOPE_GLOBAL	2
#define INET6_SCOPE_LINKLOCAL	3
#define INET6_SCOPE_SITELOCAL	4
#define INET6_SCOPE_MULTICAST	5

/* Masks */
#define	INET6_MASK_DEFAULT	0		/* 0:0:0:0:0:0:0:0 */
#define	INET6_MASK_HOST		128		/* ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff */
#define	INET6_NODE_NOMASK	0
#define	INET6_MASK_INVALID	129		/* Oops! */

/* Locate an inet mask given it's prefix length */
#define        inet6_mask_prefix(pfx)   ((pfx < 0 || pfx > 128) ? (sockaddr_un *) 0 : inet6_masks[pfx])

/* Calculate the prefix length given a mask */
#define        inet6_prefix_mask(mask) \
	(((byte *) (mask) >= inet6_mask_list && (byte *) (mask) < inet6_mask_list + sizeof inet6_mask_list) \
	? (((byte *) (mask) - inet6_mask_list) / SOCKADDR_IN6_LEN) \
	: (u_int) -1)

extern struct in6_addr inaddr6_hostmask;
extern struct in6_addr inaddr6_empty;

#ifdef	IPV6_MULTICAST
extern task *inet6_task;
#endif	/* IPV6_MULTICAST */

PROTOTYPE(inet6_mask_locate,
	  extern sockaddr_un *,
	  (sockaddr_un *));
PROTOTYPE(inet6_ifwithnet,
	  extern if_addr *,
	  (sockaddr_un *));
PROTOTYPE(inet6_family_init,
	  extern void,
	  (void));
PROTOTYPE(inet6_var_init,
	  extern void,
	  (void));
PROTOTYPE(inet6_init,
	  extern void,
	  (void));
PROTOTYPE(inet6_allrouters_join,
	  extern void,
	  (if_addr *));
PROTOTYPE(inet6_allrouters_drop,
	  extern void,
	  (if_addr *));
#ifdef V6L1
PROTOTYPE(inet6_scope_of,
	  extern byte,
	  (sockaddr_un *));
#endif
